--
-- Matrices.hs
--


module Matrices (
        matrixSolve,
        sumVector,
) where


import Numeric.LinearAlgebra


matrixSolve :: Matrix Double
            -> Vector Double
            -> Vector Double
matrixSolve m b = let
        (m', perm) = luPacked m
        in
          head $ toColumns $ luSolve (m', perm) (asColumn b)

-- Sum the elements of a vector
--
sumVector :: Vector Double
          -> Double
sumVector v = foldVector (+) 0.0 v
